package helloworld;

import hello.Service;

import java.io.IOException;
import java.net.URL;
import java.util.Enumeration;
import java.util.Hashtable;

import javax.servlet.Servlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.osgi.framework.BundleActivator;
import org.osgi.framework.BundleContext;
import org.osgi.framework.InvalidSyntaxException;
import org.osgi.framework.ServiceReference;
import org.osgi.service.http.HttpContext;
import org.osgi.service.http.HttpService;

public class Activator implements BundleActivator {
	
	public void start(BundleContext context) throws Exception {
		System.out.println("Hello Beatiful World!! "  );
		
		ClassLoader cl = Thread.currentThread().getContextClassLoader();
		Enumeration urls = cl.getResources("META-INF/helloworld.txt");
		System.out.println("Resources in bundle with classloader :" + cl);
		while(urls.hasMoreElements()) {
			URL url = (URL)urls.nextElement();
			System.out.println(url);
		}
		
		try {
			String filter = "(objectclass=" + HttpService.class.getName() + ")";

			ServiceReference[] srl = context.getServiceReferences(null, filter);
			for (int i = 0; srl != null && i < srl.length; i++) {
				register(srl[i], context);
			}
		} catch (InvalidSyntaxException e) {
			e.printStackTrace();
		}
	}
	
	public void stop(BundleContext context) throws Exception {
		System.out.println("Goodbye Ugly World!!");
	}
	
	void register(ServiceReference sr, BundleContext context) {
		HttpService http = (HttpService) context.getService(sr);

		if (http == null) {
			System.out.println("http resource is null");
			return;
		}

		try {
			Hashtable props = new Hashtable();
			http.registerServlet("/test-alias", servlet, props, null);
			http.registerResources("/www", "www", httpcontext);
		} catch (Exception e) {
			System.out.println("Failed to register resource" + e);
		}
	}
	
	Servlet servlet = new TestServlet();

	HttpContext httpcontext = new HttpContext() {
		public URL getResource(String name) {
			// and send the plain file
			URL url = getClass().getResource(name);

			return url;
		}

		public String getMimeType(String reqEntry) {
			return null; // server decides type
		}

		public boolean handleSecurity(HttpServletRequest request,
				HttpServletResponse response) throws IOException {
			// Security is handled by server
			return true;
		}
	};

}
